<template>
  <div>
    <section
      class="flex flex-col justify-center py-16 bg-white sm:px-6 lg:px-8"
    >
      <div class="sm:mx-auto sm:w-full sm:max-w-md">
        <div class="flex items-center justify-center w-full">
          <nuxt-link to="/" target="_parent">
            <Logo class="h-10" mode="dark" />
          </nuxt-link>
        </div>
      </div>

      <div class="mt-8 sm:mx-auto sm:w-full sm:max-w-md">
        <div class="px-4 py-8 bg-white shadow-lg sm:rounded-lg sm:px-10">
          <div>
            <h2 class="mb-5 text-3xl font-semibold text-black">
              Create account
            </h2>
            <form class="grid grid-cols-2 gap-5 p-y-6">
              <div class="col-span-1">
                <label
                  for="firstname"
                  class="block text-sm font-medium text-black"
                >
                  First Name
                </label>
                <div class="mt-1">
                  <input
                    id="firstname"
                    v-model="log.firstname"
                    name="firstname"
                    type="text"
                    placeholder=""
                    autocomplete="firstname"
                    required
                    class="w-full form-input"
                  />
                </div>
              </div>

              <div class="col-span-1">
                <label
                  for="lastname"
                  class="block text-sm font-medium text-black"
                >
                  Last Name
                </label>
                <div class="mt-1">
                  <input
                    id="lastname"
                    v-model="log.lastname"
                    name="lastname"
                    type="text"
                    placeholder=""
                    autocomplete="lastname"
                    required
                    class="w-full form-input"
                  />
                </div>
              </div>

              <div class="col-span-2">
                <label for="email" class="block text-sm font-medium text-black">
                  Email
                </label>
                <div class="mt-1">
                  <input
                    id="email"
                    v-model="log.email"
                    name="email"
                    type="email"
                    placeholder=""
                    autocomplete="email"
                    required
                    class="w-full form-input"
                    :class="[{ 'border-primary-200': error }]"
                  />
                </div>
              </div>

              <div class="col-span-2">
                <label
                  for="password"
                  class="block text-sm font-medium text-black"
                >
                  Password
                </label>
                <div class="mt-1">
                  <input
                    id="password"
                    v-model="log.password"
                    name="password"
                    type="password"
                    autocomplete="current-password"
                    required
                    class="w-full form-input"
                    :class="[{ 'border-primary-200': error }]"
                  />
                </div>
              </div>

              <div class="col-span-2">
                <button
                  type="submit"
                  class="btn primary large"
                  @click.prevent="register"
                >
                  <span v-if="!loading"> Create your Mōlygo account </span>
                  <span v-else>
                    <i class="text-xl text-white bx bx-loader-alt bx-spin"></i>
                  </span>
                </button>
              </div>

              <div
                v-if="error"
                class="flex items-center justify-center col-span-2 my-5"
              >
                <div class="text-center">
                  <i class="text-5xl bx bx-error text-primary-200"></i>
                </div>
                <div class="ml-5">
                  <h2 class="mb-1 font-semibold text-1xl text-primary-200">
                    A problem has occurred
                  </h2>
                  <p class="text-sm">
                    {{ error.message }}
                  </p>
                </div>
              </div>
              <!-- TODO add help -> faqs -->
            </form>
          </div>
        </div>
        <div class="my-6">
          <div class="relative">
            <div class="absolute inset-0 flex items-center">
              <div class="w-full border-t border-secondary-300"></div>
            </div>
            <div class="relative flex justify-center text-sm">
              <span class="px-2 bg-white text-secondary-300">
                Already have an account?
              </span>
            </div>
          </div>
        </div>
        <nuxt-link to="/signin" target="_parent" class="btn secondary base">
          Sign-In
        </nuxt-link>
      </div>
    </section>
  </div>
</template>

<script>
import Logo from '~/components/branding/Logo'
import registerCustomer from '~/apollo/mutations/user/registerCustomer.gql'

export default {
  components: {
    Logo,
  },
  layout: 'full',
  data() {
    return {
      log: {
        firstname: null,
        lastname: null,
        email: this.$route.params.registerEmail || null,
        password: null,
        username: null,
      },
      error: null,
      loading: false,
    }
  },
  mounted() {
    if (this.$store.state.auth.customer) {
      this.$router.push('/')
    }
  },
  methods: {
    register() {
      this.loading = true
      this.$apollo
        .mutate({
          mutation: registerCustomer,
          variables: {
            input: {
              email: this.log.email,
              password: this.log.password,
              firstName: this.log.firstname,
              lastName: this.log.lastname,
            },
          },
          update: (data) => {},
        })
        .then((data) => {
          localStorage.removeItem('log')
          this.$store.dispatch('auth/logIn', {
            username: this.log.email,
            password: this.log.password,
            redirectTo: '/profile',
          })
        })
        .catch((error) => {
          this.loading = false
          this.log.username = this.log.password = ''
          document.getElementById('email').focus()
          this.error = {
            log: error,
            message: 'The email is already been used.',
          }
        })
    },
  },
}
</script>
